## dino-im 0.4.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include(ComputeVersion)
if (NOT VERSION_FOUND)
    project(Dino LANGUAGES C CXX)
elseif (VERSION_IS_RELEASE)
    project(Dino VERSION ${VERSION_FULL} LANGUAGES C CXX)
else ()
    project(Dino LANGUAGES C CXX)
    set(PROJECT_VERSION ${VERSION_FULL})
endif ()

# Prepare Plugins
set(DEFAULT_PLUGINS omemo;openpgp;http-files;ice;rtp)
foreach (plugin ${DEFAULT_PLUGINS})
    if ("$CACHE{DINO_PLUGIN_ENABLED_${plugin}}" STREQUAL "")
        if (NOT DEFINED DINO_PLUGIN_ENABLED_${plugin}})
            set(DINO_PLUGIN_ENABLED_${plugin} "yes" CACHE BOOL "Enable plugin ${plugin}")
        else ()
            set(DINO_PLUGIN_ENABLED_${plugin} "${DINO_PLUGIN_ENABLED_${plugin}}" CACHE BOOL "Enable plugin ${plugin}" FORCE)
        endif ()
        if (DINO_PLUGIN_ENABLED_${plugin})
            message(STATUS "Enabled plugin: ${plugin}")
        else ()
            message(STATUS "Disabled plugin: ${plugin}")
        endif ()
    endif ()
endforeach (plugin)

if (DISABLED_PLUGINS)
    foreach(plugin ${DISABLED_PLUGINS})
        set(DINO_PLUGIN_ENABLED_${plugin} "no" CACHE BOOL "Enable plugin ${plugin}" FORCE)
        message(STATUS "Disabled plugin: ${plugin}")
    endforeach(plugin)
endif (DISABLED_PLUGINS)

if (ENABLED_PLUGINS)
    foreach(plugin ${ENABLED_PLUGINS})
        set(DINO_PLUGIN_ENABLED_${plugin} "yes" CACHE BOOL "Enable plugin ${plugin}" FORCE)
        message(STATUS "Enabled plugin: ${plugin}")
    endforeach(plugin)
endif (ENABLED_PLUGINS)

set(PLUGINS "")
get_cmake_property(all_variables VARIABLES)
foreach (variable_name ${all_variables})
    if (variable_name MATCHES "^DINO_PLUGIN_ENABLED_(.+)$" AND ${variable_name})
        list(APPEND PLUGINS ${CMAKE_MATCH_1})
    endif()
endforeach ()
list(SORT PLUGINS)
string(REPLACE ";" ", " PLUGINS_TEXT "${PLUGINS}")

message(STATUS "Configuring Dino ${PROJECT_VERSION} with plugins: ${PLUGINS_TEXT}")

# Prepare instal paths
macro(set_path what val desc)
    if (NOT ${what})
        unset(${what} CACHE)
        set(${what} ${val})
    endif ()
    if (NOT "${${what}}" STREQUAL "${_${what}_SET}")
        message(STATUS "${desc}: ${${what}}")
        set(_${what}_SET ${${what}} CACHE INTERNAL ${desc})
    endif()
endmacro(set_path)

string(REGEX REPLACE "^liblib" "lib" LIBDIR_NAME "lib${LIB_SUFFIX}")
set_path(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}" "Installation directory for architecture-independent files")
set_path(EXEC_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}" "Installation directory for architecture-dependent files")
set_path(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share" "Installation directory for read-only architecture-independent data")

set_path(BIN_INSTALL_DIR "${EXEC_INSTALL_PREFIX}/bin" "Installation directory for user executables")
set_path(DATA_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/dino" "Installation directory for dino-specific data")
set_path(APPDATA_FILE_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/metainfo" "Installation directory for .appdata.xml files")
set_path(DESKTOP_FILE_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/applications" "Installation directory for .desktop files")
set_path(SERVICE_FILE_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/dbus-1/services" "Installation directory for .service files")
set_path(ICON_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/icons" "Installation directory for icons")
set_path(INCLUDE_INSTALL_DIR "${EXEC_INSTALL_PREFIX}/include" "Installation directory for C header files")
set_path(LIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}/${LIBDIR_NAME}" "Installation directory for object code libraries")
set_path(LOCALE_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/locale" "Installation directory for locale files")
set_path(PLUGIN_INSTALL_DIR "${LIB_INSTALL_DIR}/dino/plugins" "Installation directory for dino plugin object code files")
set_path(VAPI_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/vala/vapi" "Installation directory for Vala API files")

set(TARGET_INSTALL LIBRARY DESTINATION ${LIB_INSTALL_DIR} RUNTIME DESTINATION ${BIN_INSTALL_DIR} PUBLIC_HEADER DESTINATION ${INCLUDE_INSTALL_DIR} ARCHIVE DESTINATION ${LIB_INSTALL_DIR})
set(PLUGIN_INSTALL LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR} RUNTIME DESTINATION ${PLUGIN_INSTALL_DIR})

include(CheckCCompilerFlag)
include(CheckCSourceCompiles)

macro(AddCFlagIfSupported list flag)
    string(REGEX REPLACE "[^a-z^A-Z^_^0-9]+" "_" flag_name ${flag})
    check_c_compiler_flag(${flag} COMPILER_SUPPORTS${flag_name})
    if (${COMPILER_SUPPORTS${flag_name}})
        set(${list} "${${list}} ${flag}")
    endif ()
endmacro()


if ("Ninja" STREQUAL ${CMAKE_GENERATOR})
    AddCFlagIfSupported(CMAKE_C_FLAGS -fdiagnostics-color)
endif ()

# Flags for all C files
AddCFlagIfSupported(CMAKE_C_FLAGS -Wall)
AddCFlagIfSupported(CMAKE_C_FLAGS -Wextra)
AddCFlagIfSupported(CMAKE_C_FLAGS -Werror=format-security)
AddCFlagIfSupported(CMAKE_C_FLAGS -Wno-duplicate-decl-specifier)
AddCFlagIfSupported(CMAKE_C_FLAGS -fno-omit-frame-pointer)

if (NOT VALA_WARN)
  set(VALA_WARN "conversion")
endif ()
set(VALA_WARN "${VALA_WARN}" CACHE STRING "Which warnings to show when invoking C compiler on Vala compiler output")
set_property(CACHE VALA_WARN PROPERTY STRINGS "all;unused;qualifier;conversion;deprecated;format;none")

# Vala generates some unused stuff
if (NOT ("all" IN_LIST VALA_WARN OR "unused" IN_LIST VALA_WARN))
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-but-set-variable)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-function)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-label)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-parameter)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-value)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-variable)
endif ()

if (NOT ("all" IN_LIST VALA_WARN OR "qualifier" IN_LIST VALA_WARN))
    AddCFlagIfSupported(VALA_CFLAGS -Wno-discarded-qualifiers)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-discarded-array-qualifiers)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-incompatible-pointer-types-discards-qualifiers)
endif ()

if (NOT ("all" IN_LIST VALA_WARN OR "deprecated" IN_LIST VALA_WARN))
    AddCFlagIfSupported(VALA_CFLAGS -Wno-deprecated-declarations)
endif ()

if (NOT ("all" IN_LIST VALA_WARN OR "format" IN_LIST VALA_WARN))
    AddCFlagIfSupported(VALA_CFLAGS -Wno-missing-braces)
endif ()

if (NOT ("all" IN_LIST VALA_WARN OR "conversion" IN_LIST VALA_WARN))
    AddCFlagIfSupported(VALA_CFLAGS -Wno-int-conversion)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-pointer-sign)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-incompatible-pointer-types)
endif ()

try_compile(__WITHOUT_FILE_OFFSET_BITS_64 ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/LargeFileOffsets.c COMPILE_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS})
if (NOT __WITHOUT_FILE_OFFSET_BITS_64)
    try_compile(__WITH_FILE_OFFSET_BITS_64 ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/LargeFileOffsets.c COMPILE_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} -D_FILE_OFFSET_BITS=64)

    if (__WITH_FILE_OFFSET_BITS_64)
        AddCFlagIfSupported(CMAKE_C_FLAGS -D_FILE_OFFSET_BITS=64)
        message(STATUS "Enabled large file support using _FILE_OFFSET_BITS=64")
    else (__WITH_FILE_OFFSET_BITS_64)
        message(STATUS "Large file support not available")
    endif (__WITH_FILE_OFFSET_BITS_64)
    unset(__WITH_FILE_OFFSET_BITS_64)
endif (NOT __WITHOUT_FILE_OFFSET_BITS_64)
unset(__WITHOUT_FILE_OFFSET_BITS_64)

if ($ENV{USE_CCACHE})
    # Configure CCache if available
    find_program(CCACHE_BIN ccache)
    mark_as_advanced(CCACHE_BIN)
    if (CCACHE_BIN)
        message(STATUS "Using ccache")
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_BIN})
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE_BIN})
    else (CCACHE_BIN)
        message(STATUS "USE_CCACHE was set but ccache was not found")
    endif (CCACHE_BIN)
endif ($ENV{USE_CCACHE})

if (NOT NO_DEBUG)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g")
    set(CMAKE_VALA_FLAGS "${CMAKE_VALA_FLAGS} -g")
endif (NOT NO_DEBUG)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

set(GLib_GLOBAL_VERSION 2.38)
set(ICU_GLOBAL_VERSION 57)

if (NOT VALA_EXECUTABLE)
    unset(VALA_EXECUTABLE CACHE)
endif ()

find_package(Vala 0.34 REQUIRED)
if (VALA_VERSION VERSION_GREATER "0.34.90" AND VALA_VERSION VERSION_LESS "0.36.1" OR # Due to a bug on 0.36.0 (and pre-releases), we need to disable FAST_VAPI
        VALA_VERSION VERSION_EQUAL "0.44.10" OR VALA_VERSION VERSION_EQUAL "0.46.4" OR VALA_VERSION VERSION_EQUAL "0.47.1" OR # See Dino issue #646
        VALA_VERSION VERSION_EQUAL "0.40.21" OR VALA_VERSION VERSION_EQUAL "0.46.8" OR VALA_VERSION VERSION_EQUAL "0.48.4") # See Dino issue #816
    set(DISABLE_FAST_VAPI yes)
endif ()

include(${VALA_USE_FILE})
include(MultiFind)
include(GlibCompileResourcesSupport)

find_package(GLib ${GLib_GLOBAL_VERSION} REQUIRED)
string(REGEX REPLACE "^([0-9]+)\\.[0-9]+(\\.[0-9]+)?" "\\1" GLib_MAJOR_VERSION "${GLib_VERSION}")
string(REGEX REPLACE "^[0-9]+\\.([0-9]+)(\\.[0-9]+)?" "\\1" GLib_MINOR_VERSION "${GLib_VERSION}")
math(EXPR GLib_LAST_RELEASE_MINOR_VERSION "${GLib_MINOR_VERSION} / 2 * 2")
set(CMAKE_VALA_FLAGS "${CMAKE_VALA_FLAGS} --target-glib=${GLib_MAJOR_VERSION}.${GLib_LAST_RELEASE_MINOR_VERSION}")

add_subdirectory(qlite)
add_subdirectory(xmpp-vala)
add_subdirectory(libdino)
add_subdirectory(main)
add_subdirectory(crypto-vala)
add_subdirectory(plugins)

# uninstall target
configure_file("${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in" "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake COMMENT "Uninstall the project...")

=== crypto-vala/CMakeLists.txt ===
find_package(GCrypt REQUIRED)
find_package(Srtp2 REQUIRED)
find_packages(CRYPTO_VALA_PACKAGES REQUIRED
    GLib
    GObject
    GIO
)

vala_precompile(CRYPTO_VALA_C
SOURCES
    "src/cipher.vala"
    "src/cipher_converter.vala"
    "src/error.vala"
    "src/random.vala"
    "src/srtp.vala"
CUSTOM_VAPIS
    "${CMAKE_CURRENT_SOURCE_DIR}/vapi/gcrypt.vapi"
    "${CMAKE_CURRENT_SOURCE_DIR}/vapi/libsrtp2.vapi"
PACKAGES
    ${CRYPTO_VALA_PACKAGES}
GENERATE_VAPI
    crypto-vala
GENERATE_HEADER
    crypto-vala
)

add_custom_target(crypto-vala-vapi
DEPENDS
    ${CMAKE_BINARY_DIR}/exports/crypto-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/crypto-vala.deps
)

add_definitions(${VALA_CFLAGS} -DG_LOG_DOMAIN="crypto-vala")
add_library(crypto-vala SHARED ${CRYPTO_VALA_C})
add_dependencies(crypto-vala crypto-vala-vapi)
target_link_libraries(crypto-vala ${CRYPTO_VALA_PACKAGES} gcrypt libsrtp2)
set_target_properties(crypto-vala PROPERTIES VERSION 0.0 SOVERSION 0)

install(TARGETS crypto-vala ${TARGET_INSTALL})
install(FILES ${CMAKE_BINARY_DIR}/exports/crypto-vala.vapi ${CMAKE_BINARY_DIR}/exports/crypto-vala.deps DESTINATION ${VAPI_INSTALL_DIR})
install(FILES ${CMAKE_BINARY_DIR}/exports/crypto-vala.h DESTINATION ${INCLUDE_INSTALL_DIR})

=== libdino/CMakeLists.txt ===
find_packages(LIBDINO_PACKAGES REQUIRED
    GDKPixbuf2
    Gee
    GLib
    GModule
    GObject
)

vala_precompile(LIBDINO_VALA_C
SOURCES
    src/application.vala

    src/dbus/login1.vala
    src/dbus/notifications.vala
    src/dbus/upower.vala

    src/entity/account.vala
    src/entity/call.vala
    src/entity/conversation.vala
    src/entity/encryption.vala
    src/entity/file_transfer.vala
    src/entity/message.vala
    src/entity/settings.vala

    src/plugin/interfaces.vala
    src/plugin/loader.vala
    src/plugin/registry.vala

    src/service/avatar_manager.vala
    src/service/blocking_manager.vala
    src/service/call_store.vala
    src/service/call_state.vala
    src/service/call_peer_state.vala
    src/service/calls.vala
    src/service/chat_interaction.vala
    src/service/connection_manager.vala
    src/service/content_item_store.vala
    src/service/conversation_manager.vala
    src/service/counterpart_interaction_manager.vala
    src/service/database.vala
    src/service/entity_capabilities_storage.vala
    src/service/entity_info.vala
    src/service/fallback_body.vala
    src/service/file_manager.vala
    src/service/file_transfer_storage.vala
    src/service/history_sync.vala
    src/service/jingle_file_transfers.vala
    src/service/message_correction.vala
    src/service/message_processor.vala
    src/service/message_storage.vala
    src/service/module_manager.vala
    src/service/muc_manager.vala
    src/service/notification_events.vala
    src/service/presence_manager.vala
    src/service/replies.vala
    src/service/reactions.vala
    src/service/registration.vala
    src/service/roster_manager.vala
    src/service/search_processor.vala
    src/service/stream_interactor.vala
    src/service/util.vala

    src/util/display_name.vala
    src/util/util.vala
    src/util/weak_map.vala
CUSTOM_VAPIS
    "${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi"
    "${CMAKE_BINARY_DIR}/exports/qlite.vapi"
CUSTOM_DEPS
    xmpp-vala
    qlite
PACKAGES
    ${LIBDINO_PACKAGES}
GENERATE_VAPI
    dino
GENERATE_HEADER
    dino
)

add_custom_command(OUTPUT "${CMAKE_BINARY_DIR}/exports/dino_i18n.h"
COMMAND
    cp "${CMAKE_CURRENT_SOURCE_DIR}/src/dino_i18n.h" "${CMAKE_BINARY_DIR}/exports/dino_i18n.h"
DEPENDS
    "${CMAKE_CURRENT_SOURCE_DIR}/src/dino_i18n.h"
COMMENT
    Copy header file dino_i18n.h
)

add_custom_target(dino-vapi
DEPENDS
    ${CMAKE_BINARY_DIR}/exports/dino.vapi
    ${CMAKE_BINARY_DIR}/exports/dino.deps
    ${CMAKE_BINARY_DIR}/exports/dino_i18n.h
)

add_definitions(${VALA_CFLAGS} -DDINO_SYSTEM_PLUGIN_DIR="${PLUGIN_INSTALL_DIR}" -DDINO_SYSTEM_LIBDIR_NAME="${LIBDIR_NAME}" -DG_LOG_DOMAIN="libdino" -DDINO_VERSION=\"${PROJECT_VERSION}\")
add_library(libdino SHARED ${LIBDINO_VALA_C} ${CMAKE_BINARY_DIR}/exports/dino_i18n.h)
add_dependencies(libdino dino-vapi)
target_link_libraries(libdino xmpp-vala qlite ${LIBDINO_PACKAGES} m)
set_target_properties(libdino PROPERTIES PREFIX "" VERSION 0.0 SOVERSION 0)

install(TARGETS libdino ${TARGET_INSTALL})
install(FILES ${CMAKE_BINARY_DIR}/exports/dino.vapi ${CMAKE_BINARY_DIR}/exports/dino.deps DESTINATION ${VAPI_INSTALL_DIR})
install(FILES ${CMAKE_BINARY_DIR}/exports/dino.h ${CMAKE_BINARY_DIR}/exports/dino_i18n.h DESTINATION ${INCLUDE_INSTALL_DIR})

if(BUILD_TESTS)
    vala_precompile(LIBDINO_TEST_VALA_C
    SOURCES
        "tests/weak_map.vala"
        "tests/testcase.vala"
        "tests/common.vala"
    CUSTOM_VAPIS
        ${CMAKE_BINARY_DIR}/exports/dino_internal.vapi
        ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi
        ${CMAKE_BINARY_DIR}/exports/qlite.vapi
    PACKAGES
        ${LIBDINO_PACKAGES}
    OPTIONS
        ${LIBDINO_EXTRA_OPTIONS}
    )

    add_definitions(${VALA_CFLAGS})
    add_executable(libdino-test ${LIBDINO_TEST_VALA_C})
    target_link_libraries(libdino-test libdino)
endif(BUILD_TESTS)

=== xmpp-vala/CMakeLists.txt ===
find_packages(ENGINE_PACKAGES REQUIRED
    GDKPixbuf2
    Gee
    GIO
    GLib
    GObject
    ICU
)

set(ENGINE_EXTRA_OPTIONS ${MAIN_EXTRA_OPTIONS} --vapidir=${CMAKE_CURRENT_SOURCE_DIR}/vapi)

vala_precompile(ENGINE_VALA_C
SOURCES
    "src/core/direct_tls_xmpp_stream.vala"
    "src/core/io_xmpp_stream.vala"
    "src/core/module_flag.vala"
    "src/core/starttls_xmpp_stream.vala"
    "src/core/stream_connect.vala"
    "src/core/tls_xmpp_stream.vala"
    "src/core/xmpp_stream.vala"

    "src/core/namespace_state.vala"
    "src/core/stanza_attribute.vala"
    "src/core/stanza_node.vala"
    "src/core/stanza_reader.vala"
    "src/core/stanza_writer.vala"
    "src/core/xmpp_log.vala"

    "src/module/bind.vala"
    "src/module/bookmarks_provider.vala"
    "src/module/conference.vala"
    "src/module/iq/module.vala"
    "src/module/iq/stanza.vala"
    "src/module/jid.vala"
    "src/module/message/module.vala"
    "src/module/message/stanza.vala"
    "src/module/presence/flag.vala"
    "src/module/presence/module.vala"
    "src/module/presence/stanza.vala"
    "src/module/roster/flag.vala"
    "src/module/roster/item.vala"
    "src/module/roster/module.vala"
    "src/module/roster/versioning_module.vala"
    "src/module/sasl.vala"
    "src/module/session.vala"
    "src/module/stanza.vala"
    "src/module/stanza_error.vala"
    "src/module/stream_error.vala"
    "src/module/util.vala"

    "src/module/xep/0048_bookmarks.vala"
    "src/module/xep/0048_conference.vala"
    "src/module/xep/0402_bookmarks2.vala"
    "src/module/xep/0004_data_forms.vala"

    "src/module/xep/0030_service_discovery/flag.vala"
    "src/module/xep/0030_service_discovery/identity.vala"
    "src/module/xep/0030_service_discovery/info_result.vala"
    "src/module/xep/0030_service_discovery/item.vala"
    "src/module/xep/0030_service_discovery/items_result.vala"
    "src/module/xep/0030_service_discovery/module.vala"

    "src/module/xep/0045_muc/flag.vala"
    "src/module/xep/0045_muc/module.vala"
    "src/module/xep/0045_muc/status_code.vala"

    "src/module/xep/0047_in_band_bytestreams.vala"
    "src/module/xep/0049_private_xml_storage.vala"
    "src/module/xep/0059_result_set_management.vala"
    "src/module/xep/0054_vcard/module.vala"
    "src/module/xep/0060_pubsub.vala"
    "src/module/xep/0065_socks5_bytestreams.vala"
    "src/module/xep/0066_out_of_band_data.vala"
    "src/module/xep/0077_in_band_registration.vala"
    "src/module/xep/0082_date_time_profiles.vala"
    "src/module/xep/0084_user_avatars.vala"
    "src/module/xep/0085_chat_state_notifications.vala"
    "src/module/xep/0115_entity_capabilities.vala"

    "src/module/xep/0166_jingle/content.vala"
    "src/module/xep/0166_jingle/content_description.vala"
    "src/module/xep/0166_jingle/content_node.vala"
    "src/module/xep/0166_jingle/content_security.vala"
    "src/module/xep/0166_jingle/content_transport.vala"
    "src/module/xep/0166_jingle/component.vala"
    "src/module/xep/0166_jingle/jingle_flag.vala"
    "src/module/xep/0166_jingle/jingle_module.vala"
    "src/module/xep/0166_jingle/jingle_structs.vala"
    "src/module/xep/0166_jingle/reason_element.vala"
    "src/module/xep/0166_jingle/session.vala"
    "src/module/xep/0166_jingle/session_info.vala"

    "src/module/xep/0167_jingle_rtp/content_parameters.vala"
    "src/module/xep/0167_jingle_rtp/content_type.vala"
    "src/module/xep/0167_jingle_rtp/jingle_rtp_module.vala"
    "src/module/xep/0167_jingle_rtp/payload_type.vala"
    "src/module/xep/0167_jingle_rtp/session_info_type.vala"
    "src/module/xep/0167_jingle_rtp/stream.vala"

    "src/module/xep/0176_jingle_ice_udp/candidate.vala"
    "src/module/xep/0176_jingle_ice_udp/jingle_ice_udp_module.vala"
    "src/module/xep/0176_jingle_ice_udp/transport_parameters.vala"

    "src/module/xep/0177_jingle_raw_udp.vala"

    "src/module/xep/0384_omemo/omemo_encryptor.vala"
    "src/module/xep/0384_omemo/omemo_decryptor.vala"

    "src/module/xep/0184_message_delivery_receipts.vala"
    "src/module/xep/0191_blocking_command.vala"
    "src/module/xep/0198_stream_management.vala"
    "src/module/xep/0199_ping.vala"
    "src/module/xep/0203_delayed_delivery.vala"
    "src/module/xep/0215_external_service_discovery.vala"
    "src/module/xep/0234_jingle_file_transfer.vala"
    "src/module/xep/0249_direct_muc_invitations.vala"
    "src/module/xep/0260_jingle_socks5_bytestreams.vala"
    "src/module/xep/0261_jingle_in_band_bytestreams.vala"
    "src/module/xep/0272_muji.vala"
    "src/module/xep/0280_message_carbons.vala"
    "src/module/xep/0297_stanza_forwarding.vala"
    "src/module/xep/0298_coin.vala"
    "src/module/xep/0308_last_message_correction.vala"
    "src/module/xep/0313_message_archive_management.vala"
    "src/module/xep/0313_2_message_archive_management.vala"
    "src/module/xep/0333_chat_markers.vala"
    "src/module/xep/0334_message_processing_hints.vala"
    "src/module/xep/0353_jingle_message_initiation.vala"
    "src/module/xep/0353_call_invite_message.vala"
    "src/module/xep/0359_unique_stable_stanza_ids.vala"
    "src/module/xep/0363_http_file_upload.vala"
    "src/module/xep/0380_explicit_encryption.vala"
    "src/module/xep/0391_jingle_encrypted_transports.vala"
    "src/module/xep/0410_muc_self_ping.vala"
    "src/module/xep/0421_occupant_ids.vala"
    "src/module/xep/0428_fallback_indication.vala"
    "src/module/xep/0444_reactions.vala"
    "src/module/xep/0461_replies.vala"
    "src/module/xep/pixbuf_storage.vala"

    "src/util.vala"
PACKAGES
    ${ENGINE_PACKAGES}
GENERATE_VAPI
    xmpp-vala
GENERATE_HEADER
    xmpp-vala
CUSTOM_VAPIS
    "${CMAKE_CURRENT_SOURCE_DIR}/src/glib_fixes.vapi"
OPTIONS
    ${ENGINE_EXTRA_OPTIONS}
)

add_custom_target(xmpp-vala-vapi
DEPENDS
    ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/xmpp-vala.deps
)

add_definitions(${VALA_CFLAGS} -DG_LOG_DOMAIN="xmpp-vala")
add_library(xmpp-vala SHARED ${ENGINE_VALA_C})
add_dependencies(xmpp-vala xmpp-vala-vapi)
target_link_libraries(xmpp-vala ${ENGINE_PACKAGES})
set_target_properties(xmpp-vala PROPERTIES VERSION 0.1 SOVERSION 0)

install(TARGETS xmpp-vala ${TARGET_INSTALL})
install(FILES ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi ${CMAKE_BINARY_DIR}/exports/xmpp-vala.deps DESTINATION ${VAPI_INSTALL_DIR})
install(FILES ${CMAKE_BINARY_DIR}/exports/xmpp-vala.h DESTINATION ${INCLUDE_INSTALL_DIR})

if(BUILD_TESTS)
    vala_precompile(ENGINE_TEST_VALA_C
    SOURCES
        "tests/common.vala"
        "tests/testcase.vala"

        "tests/jid.vala"
        "tests/stanza.vala"
        "tests/util.vala"
    CUSTOM_VAPIS
        ${CMAKE_BINARY_DIR}/exports/xmpp-vala_internal.vapi
    PACKAGES
        ${ENGINE_PACKAGES}
    OPTIONS
        ${ENGINE_EXTRA_OPTIONS}
    )

    add_definitions(${VALA_CFLAGS})
    add_executable(xmpp-vala-test ${ENGINE_TEST_VALA_C})
    target_link_libraries(xmpp-vala-test xmpp-vala ${SIGNAL_PROTOCOL_PACKAGES})
endif(BUILD_TESTS)

=== plugins/omemo/CMakeLists.txt ===
set(GETTEXT_PACKAGE "dino-omemo")
find_package(Gettext)
include(${GETTEXT_USE_FILE})
gettext_compile(${GETTEXT_PACKAGE} SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/po TARGET_NAME ${GETTEXT_PACKAGE}-translations)

find_package(Qrencode REQUIRED)
find_packages(OMEMO_PACKAGES REQUIRED
    Gee
    GLib
    GModule
    GObject
    GTK4
)

set(RESOURCE_LIST
    contact_details_dialog.ui
    manage_key_dialog.ui
)

compile_gresources(
    OMEMO_GRESOURCES_TARGET
    OMEMO_GRESOURCES_XML
    TARGET ${CMAKE_CURRENT_BINARY_DIR}/resources/resources.c
    TYPE EMBED_C
    RESOURCES ${RESOURCE_LIST}
    PREFIX /im/dino/Dino/omemo
    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/data
)

vala_precompile(OMEMO_VALA_C
SOURCES
    src/dtls_srtp_verification_draft.vala
    src/plugin.vala
    src/register_plugin.vala
    src/trust_level.vala

    src/file_transfer/file_decryptor.vala
    src/file_transfer/file_encryptor.vala
    src/jingle/jingle_helper.vala
    src/jingle/jet_omemo.vala

    src/logic/database.vala
    src/logic/decrypt.vala
    src/logic/encrypt.vala
    src/logic/manager.vala
    src/logic/pre_key_store.vala
    src/logic/session_store.vala
    src/logic/signed_pre_key_store.vala
    src/logic/trust_manager.vala

    src/protocol/bundle.vala
    src/protocol/message_flag.vala
    src/protocol/stream_module.vala

    src/ui/account_settings_entry.vala
    src/ui/bad_messages_populator.vala
    src/ui/call_encryption_entry.vala
    src/ui/contact_details_provider.vala
    src/ui/contact_details_dialog.vala
    src/ui/device_notification_populator.vala
    src/ui/own_notifications.vala
    src/ui/encryption_list_entry.vala
    src/ui/manage_key_dialog.vala
    src/ui/util.vala
CUSTOM_VAPIS
    ${CMAKE_BINARY_DIR}/exports/crypto-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/signal-protocol.vapi
    ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/qlite.vapi
    ${CMAKE_BINARY_DIR}/exports/dino.vapi
    ${CMAKE_CURRENT_SOURCE_DIR}/vapi/libqrencode.vapi
PACKAGES
    ${OMEMO_PACKAGES}
GRESOURCES
    ${OMEMO_GRESOURCES_XML}
)

add_definitions(${VALA_CFLAGS} -DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\" -DLOCALE_INSTALL_DIR=\"${LOCALE_INSTALL_DIR}\"  -DG_LOG_DOMAIN="OMEMO")
add_library(omemo SHARED ${OMEMO_VALA_C} ${OMEMO_GRESOURCES_TARGET})
add_dependencies(omemo ${GETTEXT_PACKAGE}-translations)
target_link_libraries(omemo libdino signal-protocol-vala crypto-vala ${OMEMO_PACKAGES} libqrencode)
set_target_properties(omemo PROPERTIES PREFIX "")
set_target_properties(omemo PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins/)

install(TARGETS omemo ${PLUGIN_INSTALL})

=== plugins/rtp/CMakeLists.txt ===
find_package(GLib ${GLib_GLOBAL_VERSION} REQUIRED)
find_package(WebRTCAudioProcessing 0.2)
find_packages(RTP_PACKAGES REQUIRED
    Gee
    GLib
    GModule
    GnuTLS
    GObject
    GTK4
    Gst
    GstApp
    GstAudio
    GstRtp
    GstVideo
)

set(RTP_DEFINITIONS)
set(RTP_EXTRA_OPTIONS)

if(GstRtp_VERSION VERSION_GREATER_EQUAL "1.16")
    set(RTP_DEFINITIONS ${RTP_DEFINITIONS} GST_1_16)
endif()

if(GstRtp_VERSION VERSION_GREATER_EQUAL "1.18")
    set(RTP_DEFINITIONS ${RTP_DEFINITIONS} GST_1_18)
endif()

if(GstRtp_VERSION VERSION_GREATER_EQUAL "1.20")
    set(RTP_DEFINITIONS ${RTP_DEFINITIONS} GST_1_20)
endif()

if(NOT VALA_VERSION VERSION_GREATER_EQUAL "0.56.1")
    set(RTP_EXTRA_OPTIONS ${RTP_EXTRA_OPTIONS} --vapidir=${CMAKE_CURRENT_SOURCE_DIR}/vapi)
endif()

set(RTP_ENABLE_VP9 "no" CACHE BOOL "Enable VP9 support")
if(RTP_ENABLE_VP9)
    set(RTP_DEFINITIONS ${RTP_DEFINITIONS} ENABLE_VP9)
endif()

set(RTP_ENABLE_H264 "no" CACHE BOOL "Enable H264 support")
if(RTP_ENABLE_H264)
    set(RTP_DEFINITIONS ${RTP_DEFINITIONS} ENABLE_H264)
endif()

set(RTP_ENABLE_VAAPI "no" CACHE BOOL "Enable VAAPI support")
if(RTP_ENABLE_VAAPI)
    set(RTP_DEFINITIONS ${RTP_DEFINITIONS} ENABLE_VAAPI)
endif()

set(RTP_ENABLE_MSDK "no" CACHE BOOL "Enable MSDK support")
if(RTP_ENABLE_MSDK)
    set(RTP_DEFINITIONS ${RTP_DEFINITIONS} ENABLE_MSDK)
endif()

if(WebRTCAudioProcessing_VERSION GREATER "0.4")
    message(STATUS "Ignoring WebRTCAudioProcessing, only versions < 0.4 supported so far")
    unset(WebRTCAudioProcessing_FOUND)
endif()

if(WebRTCAudioProcessing_FOUND)
    set(RTP_DEFINITIONS ${RTP_DEFINITIONS} WITH_VOICE_PROCESSOR)
    set(RTP_VOICE_PROCESSOR_VALA src/voice_processor.vala)
    set(RTP_VOICE_PROCESSOR_CXX src/voice_processor_native.cpp)
    set(RTP_VOICE_PROCESSOR_LIB webrtc-audio-processing)
else()
    message(STATUS "WebRTCAudioProcessing not found, build without voice pre-processing!")
endif()

vala_precompile(RTP_VALA_C
SOURCES
    src/codec_util.vala
    src/device.vala
    src/module.vala
    src/plugin.vala
    src/stream.vala
    src/video_widget.vala
    src/register_plugin.vala
    ${RTP_VOICE_PROCESSOR_VALA}
CUSTOM_VAPIS
    ${CMAKE_BINARY_DIR}/exports/crypto-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/dino.vapi
    ${CMAKE_BINARY_DIR}/exports/qlite.vapi
PACKAGES
    ${RTP_PACKAGES}
DEFINITIONS
    ${RTP_DEFINITIONS}
OPTIONS
    ${RTP_EXTRA_OPTIONS}
)

add_definitions(${VALA_CFLAGS} -DG_LOG_DOMAIN="rtp" -I${CMAKE_CURRENT_SOURCE_DIR}/src)
add_library(rtp SHARED ${RTP_VALA_C} ${RTP_VOICE_PROCESSOR_CXX} src/gst_fixes.c)
target_link_libraries(rtp libdino crypto-vala ${RTP_PACKAGES} gstreamer-rtp-1.0 ${RTP_VOICE_PROCESSOR_LIB})
set_target_properties(rtp PROPERTIES PREFIX "")
set_target_properties(rtp PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins/)

install(TARGETS rtp ${PLUGIN_INSTALL})

=== plugins/signal-protocol/CMakeLists.txt ===
find_package(GCrypt REQUIRED)
find_packages(SIGNAL_PROTOCOL_PACKAGES REQUIRED
    Gee
    GLib
    GObject
)

vala_precompile(SIGNAL_PROTOCOL_VALA_C
SOURCES
    "src/context.vala"
    "src/simple_iks.vala"
    "src/simple_ss.vala"
    "src/simple_pks.vala"
    "src/simple_spks.vala"
    "src/store.vala"
    "src/util.vala"
CUSTOM_VAPIS
    ${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-public.vapi
    ${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-native.vapi
PACKAGES
    ${SIGNAL_PROTOCOL_PACKAGES}
GENERATE_VAPI
    signal-protocol-vala
GENERATE_HEADER
    signal-protocol-vala
)

set(C_HEADERS_SRC "")
set(C_HEADERS_TARGET "")

if(NOT BUILD_LIBSIGNAL_IN_TREE)
    # libsignal-protocol-c has a history of breaking compatibility on the patch level
    # we'll have to check compatibility for every new release
    # distro maintainers may update this dependency after compatibility tests
    find_package(SignalProtocol 2.3.2 REQUIRED)
else()
    add_subdirectory(libsignal-protocol-c EXCLUDE_FROM_ALL)
    set_property(TARGET curve25519 PROPERTY POSITION_INDEPENDENT_CODE ON)
    set_property(TARGET protobuf-c PROPERTY POSITION_INDEPENDENT_CODE ON)
    set_property(TARGET signal-protocol-c PROPERTY POSITION_INDEPENDENT_CODE ON)

    set(SIGNAL_PROTOCOL_C_HEADERS
        signal_protocol.h
        signal_protocol_types.h
        curve.h
        hkdf.h
        ratchet.h
        protocol.h
        session_state.h
        session_record.h
        session_pre_key.h
        session_builder.h
        session_cipher.h
        key_helper.h
        sender_key.h
        sender_key_state.h
        sender_key_record.h
        group_session_builder.h
        group_cipher.h
        fingerprint.h
        device_consistency.h
    )

    file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/exports/signal")

    foreach(f ${SIGNAL_PROTOCOL_C_HEADERS})
        list(APPEND C_HEADERS_SRC "${CMAKE_CURRENT_SOURCE_DIR}/libsignal-protocol-c/src/${f}")
        list(APPEND C_HEADERS_TARGET "${CMAKE_BINARY_DIR}/exports/signal/${f}")
        add_custom_command(OUTPUT "${CMAKE_BINARY_DIR}/exports/signal/${f}"
        COMMAND
            cp "${CMAKE_CURRENT_SOURCE_DIR}/libsignal-protocol-c/src/${f}" "${CMAKE_BINARY_DIR}/exports/signal/${f}"
        DEPENDS
            "${CMAKE_CURRENT_SOURCE_DIR}/libsignal-protocol-c/src/${f}"
        COMMENT
            Copy header file signal/${f}
        )
    endforeach(f)
endif()

list(APPEND C_HEADERS_SRC "${CMAKE_CURRENT_SOURCE_DIR}/src/signal_helper.h")
list(APPEND C_HEADERS_TARGET "${CMAKE_BINARY_DIR}/exports/signal_helper.h")

add_custom_command(OUTPUT "${CMAKE_BINARY_DIR}/exports/signal_helper.h"
COMMAND
    cp "${CMAKE_CURRENT_SOURCE_DIR}/src/signal_helper.h" "${CMAKE_BINARY_DIR}/exports/signal_helper.h"
DEPENDS
    "${CMAKE_CURRENT_SOURCE_DIR}/src/signal_helper.h"
COMMENT
    Copy header file signal_helper.h
)

add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/exports/signal-protocol.vapi
COMMAND
    cat "${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-public.vapi" "${CMAKE_BINARY_DIR}/exports/signal-protocol-vala.vapi" > "${CMAKE_BINARY_DIR}/exports/signal-protocol.vapi"
DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-public.vapi
    ${CMAKE_BINARY_DIR}/exports/signal-protocol-vala.vapi
)

add_custom_target(signal-protocol-vapi
DEPENDS
    ${CMAKE_BINARY_DIR}/exports/signal-protocol.vapi
    ${CMAKE_BINARY_DIR}/exports/signal-protocol-vala.h
    ${C_HEADERS_TARGET}
)

set(CFLAGS ${VALA_CFLAGS} -I${CMAKE_CURRENT_SOURCE_DIR}/libsignal-protocol-c/src -I${CMAKE_CURRENT_SOURCE_DIR}/src)
add_definitions(${CFLAGS})
add_library(signal-protocol-vala STATIC ${SIGNAL_PROTOCOL_VALA_C} ${CMAKE_CURRENT_SOURCE_DIR}/src/signal_helper.c)
add_dependencies(signal-protocol-vala signal-protocol-vapi)
target_link_libraries(signal-protocol-vala ${SIGNAL_PROTOCOL_PACKAGES} gcrypt signal-protocol-c m)
set_property(TARGET signal-protocol-vala PROPERTY POSITION_INDEPENDENT_CODE ON)

if(BUILD_TESTS)
    vala_precompile(SIGNAL_TEST_VALA_C
    SOURCES
        "tests/common.vala"
        "tests/testcase.vala"

        "tests/curve25519.vala"
        "tests/hkdf.vala"
        "tests/session_builder.vala"
    CUSTOM_VAPIS
        ${CMAKE_BINARY_DIR}/exports/signal-protocol-vala_internal.vapi
        ${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-public.vapi
        ${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-native.vapi
    PACKAGES
        ${SIGNAL_PROTOCOL_PACKAGES}
    )

    set(CFLAGS ${VALA_CFLAGS} -I${CMAKE_CURRENT_BINARY_DIR}/signal-protocol)
    add_executable(signal-protocol-vala-test ${SIGNAL_TEST_VALA_C})
    add_dependencies(signal-protocol-vala-test signal-protocol-vala)
    target_link_libraries(signal-protocol-vala-test signal-protocol-vala ${SIGNAL_PROTOCOL_PACKAGES})
endif(BUILD_TESTS)

=== debian/changelog ===
dino-im (0.4.3-3) unstable; urgency=medium

  * Add upstream commit to fix implicit-function-declaration (Closes: #1066528)

 -- Martin <debacle@debian.org>  Wed, 13 Mar 2024 17:48:38 +0000

dino-im (0.4.3-2) unstable; urgency=medium

  [ John Scott ]
  * Switch the Homepage to dino.im

 -- Martin <debacle@debian.org>  Tue, 11 Jul 2023 20:14:59 +0000

dino-im (0.4.3-1) unstable; urgency=medium

  * Maintenance release with bug fixes.

 -- Martin <debacle@debian.org>  Tue, 11 Jul 2023 18:26:18 +0000

=== debian/control ===
Source: dino-im
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Uploaders: Martin <debacle@debian.org>,
           Taowa <taowa@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
	cmake,
	dh-exec,
	gettext,
	libadwaita-1-dev,
	libgcrypt20-dev,
	libgee-0.8-dev,
	libglib2.0-dev,
	libgpgme-dev,
	libgspell-1-dev,
	libgstreamer-plugins-base1.0-dev,
	libgstreamer1.0-dev,
	libgtk-4-dev,
	libicu-dev,
	libnice-dev,
	libnotify-dev,
	libqrencode-dev,
	libsignal-protocol-c-dev (>= 2.3.2~),
	libsoup-3.0-dev,
	libsqlite3-dev,
	libsrtp2-dev,
	libwebrtc-audio-processing-dev,
	ninja-build,
	valac,
Standards-Version: 4.1.4
Rules-Requires-Root: no
Homepage: https://dino.im
Vcs-Browser: https://salsa.debian.org/xmpp-team/dino-im
Vcs-Git: https://salsa.debian.org/xmpp-team/dino-im.git

Package: dino-im
Architecture: any
Depends: ${misc:Depends},
	${shlibs:Depends},
	dino-im-common (= ${source:Version}),
	libgtk-4-media-gstreamer,
	libgstreamer-plugins-base1.0-0,
Recommends: ca-certificates,
	dbus,
	fonts-noto-color-emoji,
	network-manager
Breaks: dino-im-common (<< 0.1.0-5~)
Replaces: dino-im-common (<< 0.1.0-5~)
Description: modern XMPP client
 Dino is a modern XMPP/Jabber client with a nice and clean look.
 It does support OMEMO and OpenPGP for end-to-end encryption
 and encrypted audio/video calls between two or more people.
 If you are looking for a Conversations look-alike, this
 program might be for you.

Package: dino-im-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: dino-im (<< 0.1.0-5~)
Description: modern XMPP client - common files
 Dino is a modern XMPP/Jabber client with a nice and clean look.
 It does support OMEMO and OpenPGP for end-to-end encryption
 and encrypted audio/video calls between two or more people.
 If you are looking for a Conversations look-alike, this
 program might be for you.
 .
 This package contains platform independent files.

## dino-im 0.4.4

=== main/CMakeLists.txt ===
set(GETTEXT_PACKAGE "dino")
find_package(Gettext)
include(${GETTEXT_USE_FILE})
gettext_compile(${GETTEXT_PACKAGE} SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/po TARGET_NAME ${GETTEXT_PACKAGE}-translations)

find_package(GTK4 REQUIRED)
find_packages(MAIN_PACKAGES REQUIRED
    Gee
    GLib
    GModule
    GObject
    GTK4
    ICU
    Adwaita
)

set(RESOURCE_LIST
    dino-conversation-list-placeholder-arrow.svg

    icons/scalable/actions/dino-account-plus-symbolic.svg
    icons/scalable/actions/dino-emoticon-add-symbolic.svg
    icons/scalable/actions/dino-emoticon-symbolic.svg
    icons/scalable/actions/dino-qr-code-symbolic.svg

    icons/scalable/apps/im.dino.Dino.svg
    icons/scalable/apps/im.dino.Dino-symbolic.svg

    icons/scalable/devices/dino-device-desktop-symbolic.svg
    icons/scalable/devices/dino-device-phone-symbolic.svg
    icons/scalable/devices/dino-phone-hangup-symbolic.svg
    icons/scalable/devices/dino-phone-in-talk-symbolic.svg
    icons/scalable/devices/dino-phone-missed-symbolic.svg
    icons/scalable/devices/dino-phone-ring-symbolic.svg
    icons/scalable/devices/dino-phone-symbolic.svg

    icons/scalable/mimetypes/dino-file-document-symbolic.svg
    icons/scalable/mimetypes/dino-file-download-symbolic.svg
    icons/scalable/mimetypes/dino-file-image-symbolic.svg
    icons/scalable/mimetypes/dino-file-music-symbolic.svg
    icons/scalable/mimetypes/dino-file-symbolic.svg
    icons/scalable/mimetypes/dino-file-table-symbolic.svg
    icons/scalable/mimetypes/dino-file-video-symbolic.svg

    icons/scalable/status/dino-double-tick-symbolic.svg
    icons/scalable/status/dino-microphone-off-symbolic.svg
    icons/scalable/status/dino-microphone-symbolic.svg
    icons/scalable/status/dino-party-popper-symbolic.svg
    icons/scalable/status/dino-security-high-symbolic.svg
    icons/scalable/status/dino-status-away.svg
    icons/scalable/status/dino-status-chat.svg
    icons/scalable/status/dino-status-dnd.svg
    icons/scalable/status/dino-status-online.svg
    icons/scalable/status/dino-tick-symbolic.svg
    icons/scalable/status/dino-video-off-symbolic.svg
    icons/scalable/status/dino-video-symbolic.svg

    add_conversation/add_contact_dialog.ui
    add_conversation/add_groupchat_dialog.ui
    add_conversation/conference_details_fragment.ui
    add_conversation/list_row.ui
    add_conversation/select_jid_fragment.ui

    call_widget.ui
    chat_input.ui
    contact_details_dialog.ui
    conversation_item_widget.ui
    conversation_list_titlebar.ui
    conversation_list_titlebar_csd.ui
    conversation_row.ui
    conversation_view.ui
    file_default_widget.ui
    file_send_overlay.ui
    global_search.ui
    conversation_content_view/item_metadata_header.ui
    conversation_content_view/view.ui
    manage_accounts/account_row.ui
    manage_accounts/add_account_dialog.ui
    manage_accounts/dialog.ui
    menu_add.ui
    menu_app.ui
    menu_conversation.ui
    menu_encryption.ui
    message_item_widget_edit_mode.ui
    occupant_list.ui
    occupant_list_item.ui
    quote.ui
    search_autocomplete.ui
    settings_dialog.ui
    shortcuts.ui
    unified_main_content.ui
    unified_window_placeholder.ui

    style.css
    style-dark.css
)

compile_gresources(
    MAIN_GRESOURCES_TARGET
    MAIN_GRESOURCES_XML
    TARGET ${CMAKE_CURRENT_BINARY_DIR}/resources/resources.c
    TYPE EMBED_C
    RESOURCES ${RESOURCE_LIST}
    PREFIX /im/dino/Dino
    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/data
)

unset(MAIN_EXTRA_OPTIONS)
unset(MAIN_EXTRA_PACKAGES)
set(MAIN_EXTRA_OPTIONS ${MAIN_EXTRA_OPTIONS} --vapidir=${CMAKE_CURRENT_SOURCE_DIR}/vapi)

set(MAIN_DEFINITIONS)
if(GTK4_VERSION VERSION_GREATER_EQUAL "4.6")
    set(MAIN_DEFINITIONS ${MAIN_DEFINITIONS} GTK_4_6)
endif()
if(GTK4_VERSION VERSION_GREATER_EQUAL "4.8")
    set(MAIN_DEFINITIONS ${MAIN_DEFINITIONS} GTK_4_8)
endif()
if(Adwaita_VERSION VERSION_GREATER_EQUAL "1.2")
    set(MAIN_DEFINITIONS ${MAIN_DEFINITIONS} Adw_1_2)
endif()

vala_precompile(MAIN_VALA_C
SOURCES
    src/main.vala

    src/ui/application.vala
    src/ui/avatar_drawer.vala
    src/ui/avatar_image.vala
    src/ui/conversation_list_titlebar.vala
    src/ui/conversation_view.vala
    src/ui/conversation_view_controller.vala
    src/ui/file_send_overlay.vala
    src/ui/global_search.vala
    src/ui/notifier_freedesktop.vala
    src/ui/notifier_gnotifications.vala
    src/ui/settings_dialog.vala
    src/ui/main_window.vala
    src/ui/main_window_controller.vala

    src/ui/add_conversation/add_conference_dialog.vala
    src/ui/add_conversation/add_contact_dialog.vala
    src/ui/add_conversation/add_groupchat_dialog.vala
    src/ui/add_conversation/conference_details_fragment.vala
    src/ui/add_conversation/conference_list.vala
    src/ui/add_conversation/list_row.vala
    src/ui/add_conversation/roster_list.vala
    src/ui/add_conversation/select_contact_dialog.vala
    src/ui/add_conversation/select_jid_fragment.vala

    src/ui/call_window/audio_settings_popover.vala
    src/ui/call_window/call_bottom_bar.vala
    src/ui/call_window/call_connection_details_window.vala
    src/ui/call_window/call_encryption_button.vala
    src/ui/call_window/call_window.vala
    src/ui/call_window/call_window_controller.vala
    src/ui/call_window/participant_widget.vala
    src/ui/call_window/video_settings_popover.vala

    src/ui/conversation_content_view/call_widget.vala
    src/ui/conversation_content_view/chat_state_populator.vala
    src/ui/conversation_content_view/content_populator.vala
    src/ui/conversation_content_view/conversation_item_skeleton.vala
    src/ui/conversation_content_view/conversation_view.vala
    src/ui/conversation_content_view/date_separator_populator.vala
    src/ui/conversation_content_view/file_default_widget.vala
    src/ui/conversation_content_view/file_image_widget.vala
    src/ui/conversation_content_view/file_widget.vala
    src/ui/conversation_content_view/item_actions.vala
    src/ui/conversation_content_view/message_widget.vala
    src/ui/conversation_content_view/quote_widget.vala
    src/ui/conversation_content_view/reactions_widget.vala
    src/ui/conversation_content_view/subscription_notification.vala

    src/ui/chat_input/chat_input_controller.vala
    src/ui/chat_input/chat_text_view.vala
    src/ui/chat_input/encryption_button.vala
    src/ui/chat_input/occupants_tab_completer.vala
    src/ui/chat_input/smiley_converter.vala
    src/ui/chat_input/view.vala

    src/ui/contact_details/blocking_provider.vala
    src/ui/contact_details/settings_provider.vala
    src/ui/contact_details/permissions_provider.vala
    src/ui/contact_details/dialog.vala
    src/ui/contact_details/muc_config_form_provider.vala

    src/ui/conversation_selector/conversation_selector.vala
    src/ui/conversation_selector/conversation_selector_row.vala

    src/ui/conversation_titlebar/call_entry.vala
    src/ui/conversation_titlebar/menu_entry.vala
    src/ui/conversation_titlebar/occupants_entry.vala
    src/ui/conversation_titlebar/search_entry.vala
    src/ui/conversation_titlebar/conversation_titlebar.vala

    src/ui/manage_accounts/account_row.vala
    src/ui/manage_accounts/add_account_dialog.vala
    src/ui/manage_accounts/dialog.vala

    src/ui/occupant_menu/list.vala
    src/ui/occupant_menu/list_row.vala
    src/ui/occupant_menu/view.vala

    src/ui/util/accounts_combo_box.vala
    src/ui/util/config.vala
    src/ui/util/data_forms.vala
    src/ui/util/helper.vala
    src/ui/util/label_hybrid.vala
    src/ui/util/sizing_bin.vala
    src/ui/util/size_request_box.vala

    src/ui/widgets/date_separator.vala
    src/ui/widgets/fixed_ratio_picture.vala
    src/ui/widgets/natural_size_increase.vala
CUSTOM_VAPIS
    ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/qlite.vapi
    ${CMAKE_BINARY_DIR}/exports/dino_internal.vapi
PACKAGES
    ${MAIN_PACKAGES}
    ${MAIN_EXTRA_PACKAGES}
GRESOURCES
    ${MAIN_GRESOURCES_XML}
DEFINITIONS
    ${MAIN_DEFINITIONS}
OPTIONS
    ${MAIN_EXTRA_OPTIONS}
)

add_definitions(${VALA_CFLAGS} -DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\" -DLOCALE_INSTALL_DIR=\"${LOCALE_INSTALL_DIR}\" -DG_LOG_DOMAIN="dino")
add_executable(dino ${MAIN_VALA_C} ${MAIN_GRESOURCES_TARGET})
add_dependencies(dino ${GETTEXT_PACKAGE}-translations)
target_include_directories(dino PRIVATE src)
target_link_libraries(dino libdino ${MAIN_PACKAGES})
set_target_properties(dino PROPERTIES ENABLE_EXPORTS TRUE)

if(WIN32)
    target_link_libraries(dino -mwindows)
endif(WIN32)

install(TARGETS dino ${TARGET_INSTALL})
install(FILES data/im.dino.Dino.appdata.xml DESTINATION ${APPDATA_FILE_INSTALL_DIR})
install(FILES data/im.dino.Dino.desktop DESTINATION ${DESKTOP_FILE_INSTALL_DIR})
install(FILES data/im.dino.Dino.service DESTINATION ${SERVICE_FILE_INSTALL_DIR})
install(FILES data/icons/scalable/apps/im.dino.Dino.svg DESTINATION ${ICON_INSTALL_DIR}/hicolor/scalable/apps)
install(FILES data/icons/scalable/apps/im.dino.Dino-symbolic.svg DESTINATION ${ICON_INSTALL_DIR}/hicolor/symbolic/apps)

=== debian/changelog ===
dino-im (0.4.4-1ubuntu2) plucky; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 06 Jan 2025 05:30:09 +0100

dino-im (0.4.4-1ubuntu1) plucky; urgency=medium

  * d/control: replace libwebrtc-audio-processing-dev with new package name
    libwebrtc-audio-processing-1-dev.

 -- Mateus Rodrigues de Morais <mateus.morais@canonical.com>  Thu, 19 Dec 2024 13:03:41 -0300

dino-im (0.4.4-1) unstable; urgency=medium

  * Maintenance release with bug fixes.
  * Drop obsolete upstream patches.

 -- Martin <debacle@debian.org>  Thu, 04 Jul 2024 21:28:33 +0000

dino-im (0.4.3-4) unstable; urgency=medium

  * Add patch to fix compatibility with valac 0.56.17 (Closes: #1070457)

 -- Martin <debacle@debian.org>  Sun, 05 May 2024 19:48:57 +0000

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: dino-im
-Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
 Uploaders: Martin <debacle@debian.org>,
            Taowa <taowa@debian.org>
 Section: net
@@ -25,7 +26,7 @@
 	libsoup-3.0-dev,
 	libsqlite3-dev,
 	libsrtp2-dev,
-	libwebrtc-audio-processing-dev,
+	libwebrtc-audio-processing-1-dev,
 	ninja-build,
 	valac,
 Standards-Version: 4.1.4

## dino-im 0.4.5

=== plugins/rtp/CMakeLists.txt ===
--- 
+++ 
@@ -53,16 +53,25 @@
     set(RTP_DEFINITIONS ${RTP_DEFINITIONS} ENABLE_MSDK)
 endif()
 
-if(WebRTCAudioProcessing_VERSION GREATER "0.4")
-    message(STATUS "Ignoring WebRTCAudioProcessing, only versions < 0.4 supported so far")
+if(WebRTCAudioProcessing_VERSION GREATER_EQUAL "3.0")
+    message(STATUS "Ignoring WebRTCAudioProcessing, only versions 0.2+, 1.* and 2.* supported so far")
     unset(WebRTCAudioProcessing_FOUND)
 endif()
 
 if(WebRTCAudioProcessing_FOUND)
     set(RTP_DEFINITIONS ${RTP_DEFINITIONS} WITH_VOICE_PROCESSOR)
+    if(WebRTCAudioProcessing_VERSION GREATER_EQUAL "2.0")
+        set(RTP_VOICE_PROCESSOR_CFLAGS "-DWEBRTC2")
+        set(RTP_VOICE_PROCESSOR_LIB webrtc-audio-processing-2)
+    elseif(WebRTCAudioProcessing_VERSION GREATER_EQUAL "1.0")
+        set(RTP_VOICE_PROCESSOR_CFLAGS "-DWEBRTC1")
+        set(RTP_VOICE_PROCESSOR_LIB webrtc-audio-processing-1)
+    else()
+        set(RTP_VOICE_PROCESSOR_CFLAGS "-DWEBRTC0")
+        set(RTP_VOICE_PROCESSOR_LIB webrtc-audio-processing)
+    endif()
     set(RTP_VOICE_PROCESSOR_VALA src/voice_processor.vala)
     set(RTP_VOICE_PROCESSOR_CXX src/voice_processor_native.cpp)
-    set(RTP_VOICE_PROCESSOR_LIB webrtc-audio-processing)
 else()
     message(STATUS "WebRTCAudioProcessing not found, build without voice pre-processing!")
 endif()
@@ -90,7 +99,7 @@
     ${RTP_EXTRA_OPTIONS}
 )
 
-add_definitions(${VALA_CFLAGS} -DG_LOG_DOMAIN="rtp" -I${CMAKE_CURRENT_SOURCE_DIR}/src)
+add_definitions(${VALA_CFLAGS} -DG_LOG_DOMAIN="rtp" -I${CMAKE_CURRENT_SOURCE_DIR}/src ${RTP_VOICE_PROCESSOR_CFLAGS})
 add_library(rtp SHARED ${RTP_VALA_C} ${RTP_VOICE_PROCESSOR_CXX} src/gst_fixes.c)
 target_link_libraries(rtp libdino crypto-vala ${RTP_PACKAGES} gstreamer-rtp-1.0 ${RTP_VOICE_PROCESSOR_LIB})
 set_target_properties(rtp PROPERTIES PREFIX "")

=== debian/changelog ===
dino-im (0.4.5-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Martin <debacle@debian.org>  Sun, 02 Mar 2025 08:53:53 +0000

dino-im (0.4.5-1) unstable; urgency=medium

  * Maintenance release with bug fixes.

 -- Martin <debacle@debian.org>  Mon, 24 Feb 2025 21:52:00 +0000
